var gulp = require("gulp");
var $ = require('gulp-load-plugins')();
var $path = require("path");
var fs = require("fs");
var through = require("through2");
var defaultObj = {
    modulename: "starter",
    css: {
        "./style.less": {
            name: "style.css",
            dest: ["./"]
        }
    },
    js: {
        "./main/main.js": {
            name: "main.js",
            dest: ["./"]
        }
    },
    concat: {
        src: ["./main.js", "./lib/ionic/js/ionic.bundle.min.js"],
        name: "concat.js",
        dest: ["./"]
    },
    watch: ["style.less", "main/**"],
    liverload: false,
    deploy: {
        src: ["index.html", "style.css", "concat.js"],
        // dest: {
        //     "./dist": {
        //         sync: false // 是否在编译的同时也dest  是
        //     },
        //     "../ssss": {
        //         sync: false // 是否在编译的同时也dest 否
        //     }
        // }
    }
};
var concatHandlerLists = [];
var browserifyHandlerLists = [];
var deployHandlerLists = [];
var app = {
    start: function(config, func) {
        func = func || function() {};
        config = mix(defaultObj, config);
        gulp.task("less", function(cb) {
            less(config.css, cb);
        })
        gulp.task("browserify", function(cb) {
            browserify(config.js, cb, config);
        });
        // 在合并之前，需要先browserify
        gulp.task("concat", ["browserify"], function(cb) {
            concat(config.concat, cb);
        });
        gulp.task("watch", function() {
            watch(config)
        })
        gulp.task("livereload", function() {
            $.livereload.listen();
        });
        gulp.task("deploylocal", ['concat', 'less'])
        var arr = ['deploylocal', 'watch'];
        if (config.liverload) {
            arr.push("livereload");
        };
        gulp.task("deploy", ['concat', 'less'], function(cb) {
            // 迁移
            deploy(config, cb);
        })
        gulp.task("default", arr, function() {
            func();
        });
    },
    addConcatHandler: function(func) {
        concatHandlerLists.push(func);
    },
    addBrowserifyHandler: function(func) {
        browserifyHandlerLists.push(func);
    },
    addDeployHander: function(func) {
        deployHandlerLists.push(func);
    }
}

function deploy(config, cb, isInBrowserify) {
    try {
        var sum = 0;
        var flag = 0;
        cb = cb || function() {};

        for (var i in config.deploy.dest) {
            sum++;
            var deldir = $path.join(process.cwd(), i);
            del(deldir);
            (function(i) {
                gulp.src(config.deploy.src)
                    .pipe(gulp.dest(function(f) {
                        var relative = $path.relative(process.cwd(), f.path);
                        var destfile = $path.join(process.cwd(), i, relative);
                        var dest = $path.dirname(destfile);
                        console.log(dest)
                        return dest;
                    }))
                    .on("end", function() {
                        flag++;
                        if (flag == sum) {
                            console.log("结束deploy")
                            cb();
                        }
                    })
            })(i);

            // var stream = gulp.src(config.deploy.src)
            // .pipe()
            // 在监听jS时触发的
            // if(isInBrowserify && config.deploy.dest[i].sync && i != 0) {
            // 	var deldir = $path.join(process.cwd(),i);
            // 	// del(deldir);
            // 	(function(i){
            // 		sum++;
            // 		gulp.src(config.deploy.src)
            // 		.pipe(through.obj(function(file,enc,cb1){
            // 			var path = $path.relative(process.cwd(),file.path);
            // 			var absolutepath = $path.join(process.cwd(),i,$path.dirname(path));
            // 			var me = this;
            // 			gulp.src(path)
            // 				.pipe(through.obj(function(file,enc,cb){
            // 					if(deployHandlerLists.length > 0) {
            // 						var content = file.contents.toString();
            // 						var result = execLists(browserifyHandlerLists,{contents: content,file: file});
            // 						file.contents = new Buffer(result);
            // 					}
            // 					this.push(file);
            // 					cb();
            // 				}))
            // 				.pipe(gulp.dest(absolutepath))
            // 				.on("end",function(){
            // 					me.push(file);
            // 					cb1();
            // 				})
            // 		}))
            // 		// .pipe(gulp.dest(config.deploy.dest[i]))
            // 		.on("end",function(){
            // 			flag++;
            // 			if(flag == sum) {
            // 				console.log("结束deploy")
            // 				cb();
            // 			}
            // 		});
            // 	})(i)
            // } else if(!isInBrowserify && i != 0){
            // 	var deldir = $path.join(process.cwd(),i);
            // 	del(deldir);
            // 	(function(i){
            // 		sum++;
            // 		gulp.src(config.deploy.src)
            // 		.pipe(through.obj(function(file,enc,cb){
            // 			var path = $path.relative(process.cwd(),file.path);
            // 			var absolutepath = $path.join(process.cwd(),i,$path.dirname(path));
            // 			gulp.src(path)
            // 				.pipe(through.obj(function(file,enc,cb){
            // 					if(deployHandlerLists.length > 0) {
            // 						var content = file.contents.toString("utf8");
            // 						var result = execLists(deployHandlerLists,{contents: content,file: file});
            // 						file.contents = new Buffer(result);
            // 					}
            // 					this.push(file);
            // 					cb();
            // 				}))
            // 				.pipe(gulp.dest(absolutepath));
            // 			cb();
            // 		}))
            // 		// .pipe(gulp.dest(config.deploy.dest[i]))
            // 		.on("end",function(){
            // 			flag++;
            // 			if(flag == sum) {
            // 				console.log("结束deploy")
            // 				cb();
            // 			}
            // 		});
            // 	})(i);
            // }
        }
    } catch (e) {
        console.log(e);
    }
}

function less(obj, cb) {
    console.log("即将开始执行less操作")
    try {
        var cssmin = require("gulp-minify-css");
        var sum = 0;
        var flag = 0;
        for (var i in obj) {
            sum++;
            var stream = gulp.src(i)
                .pipe($.plumber({
                    errorHandler: handleError
                }))
                .pipe($.less())
                .pipe(cssmin())
                .pipe($.rename(obj[i].name))
                .pipe($.livereload())
                .on("end", function() {
                    flag++;
                    if (cb && flag == sum) {
                        console.log("结束less")
                        cb();
                    }
                });
            for (var j in obj[i].dest) {
                stream.pipe(gulp.dest(obj[i].dest[j]));
            }
        }
    } catch (e) {
        console.log(e);
    }
};

function browserify(obj, cb, config, isInDeploy) {
    console.log("即将开始执行browserify操作")
    var sum = 0;
    var flag = 0;
    cb = cb || function() {};
    for (var i in obj) {
        sum++;
        var stream = gulp.src(i)
            .pipe($.plumber({
                errorHandler: handleError
            }))
            .pipe($.browserify())
            .pipe($.ngAnnotate())
            .pipe($.rename(obj[i].name))
            .pipe(through.obj(function(file, enc, cb) {
                if (!isInDeploy && browserifyHandlerLists.length > 0) {
                    var content = file.contents.toString();
                    var result = execLists(browserifyHandlerLists, content);
                    file.contents = new Buffer(result);
                }
                this.push(file);
                cb();
            }))
            .pipe($.livereload())
            .on("end", function() {
                flag++;
                if (cb && flag == sum) {
                    console.log("结束browserify")
                    cb();
                    concat(config.concat, function() {
                        // deploy(config,null,true);
                    })
                }
            })
        if (obj[i].mini) {
            stream.pipe($.uglify());
        }
        for (var j in obj[i].dest) {
            stream.pipe(gulp.dest(obj[i].dest[j]));
        }
    }
}

function execLists(arr, data) {
    function handler(arr, i, data) {
        if (i < arr.length && typeof arr[i] == "function") {
            if (i == arr.length - 1) {
                // 最后一列了
                return arr[i](data);
            } else {
                // 并不是最后的，那就以上一次的结果作为输入
                var j = i + 1;
                data = handler(arr, j, arr[i](data));
            }
        }
        return data;
    }
    if (arr instanceof Array) {
        data = handler(arr, 0, data);
    }
    return data;
}

function execLists(arr, param) {
    var data = null;

    function handler(arr, i, param) {
        if (i < arr.length && typeof arr[i] == "function") {
            if (i == arr.length - 1) {
                // 最后一列了
                return arr[i](param);
            } else {
                // 并不是最后的，那就以上一次的结果作为输入
                var j = i + 1;
                data = handler(arr, j, arr[i](param));
            }
        }
        return data;
    }
    if (arr instanceof Array) {
        data = handler(arr, 0, param);
    }
    return data;
}

function concat(obj, cb) {
    console.log("即将开始执行concat操作")
    cb = cb || function() {};
    // concat 依赖于browserfy
    var stream = gulp.src(obj.src)
        .pipe($.plumber({
            errorHandler: handleError
        }))
        .pipe($.concat(obj.name))
        .pipe(through.obj(function(file, enc, cb) {
            if (concatHandlerLists.length > 0) {
                var content = file.contents.toString();
                var result = execLists(concatHandlerLists, content);
                file.contents = new Buffer(result);
            }
            this.push(file);
            cb();
        }))
        .on("end", function() {
            console.log("完成concat操作")
            cb();
        });
    for (var i in obj.dest) {
        stream.pipe(gulp.dest(obj.dest[i]));
    }
};

function watch(obj) {
    for (var i in obj.watch) {
        (function(i) {
            var watcher = gulp.watch(obj.watch[i], function(e) {
                    console.log("监听到文件：", e.path, "发生了变化")
                    var dirname = $path.join(process.cwd(), obj.watch[i].split("*")[0]);
                    if (e.path.indexOf(dirname) >= 0) {
                        execWatch(e, obj);
                    }
                })
                .on("error", function(e) {
                    console.log(e);
                })
        })(i)
    }
};

function execWatch(e, obj) {
    var path = e.path; // 绝对路径
    var ext = require("path").extname(path);
    switch (ext) {
        case ".html":
            execHtml(e, obj);
            break;
        case ".less":
            execLess(e, obj.css);
            break;
        case ".js":
            execJs(e, ext, obj.js, obj.modulename, obj);
        default:
            execLess(e, obj.css, function() {
                execJs(e, ext, obj.js, obj.modulename, obj);
            });
    }
};

function execHtml(event, obj) {
    var path = event.path;
    var Path = require("path");
    var basename = Path.basename(path);
    var dir = Path.dirname(path);
    var tplsName = Path.relative(__dirname, dir) + "/";
    gulp.src(path)
        .pipe($.plumber({
            errorHandler: handleError
        }))
        .pipe($.ngHtml2js({
            moduleName: obj.modulename,
            prefix: tplsName,
            standalone: true
        }))
        .pipe($.footer("module.exports='<%= name %>';", { name: tplsName + basename }))
        .pipe(gulp.dest(dir))
        .on("end", function() {
            browserify(obj.js, function() {}, obj);
        })
};

function execLess(e, obj, cb) {
    cb = cb || function() {};
    try {
        var basename = require("path").basename(e.path);
        var dirname = require("path").dirname(e.path);
        var parentMainPath = dirname + "/style.less";
        var extname = require("path").extname(e.path);
        if (e.type == "added") {
            // 新增了
            var stat = fs.statSync(e.path);
            var isFile = stat.isFile();
            if (basename !== "style.less" && extname != ".js") {
                gulp.src(parentMainPath)
                    .pipe($.footer(isFile ? "@import './<%= path %>';\n" : "@import './<%= path %>/style';\n", { path: basename }))
                    .pipe(gulp.dest(dirname))
                    .on("end", function() {
                        // 结束了 开始执行browserify的操作
                        if (!isFile) {
                            // 不是个文件 是文件夹
                            var ws = fs.createWriteStream($path.join(e.path, "./style.less"));
                            ws.write("");
                            ws.end();
                            less(obj, cb);
                        } else {
                            fs.writeFile(e.path, " ", { encoding: "utf8" }, function() {
                                less(obj, cb);
                            });
                        }
                    })
            }
        } else if (e.type == 'deleted') {
            var ext = $path.extname(e.path);
            var basename = $path.basename(e.path, ".less");
            var dirname = $path.dirname(e.path);
            var state = fs.statSync(dirname + "/style.less");
            if (state.isFile()) {
                //是个文件  读取文件
                var content_ = fs.readFileSync(dirname + "/style.less").toString();
                var require_reg = new RegExp("@import (\'|" + '\")\\.' + $path.sep + '(' + basename + "|" + basename + ".less)(\'" + '|\");', "gi");
                content_ = content_.replace(require_reg, "");
                fs.writeFile(dirname + "/style.less", content_, {
                    encoding: "utf-8"
                })
            }
        } else {
            less(obj, cb);
        }
    } catch (e) {
        console.log(e);
    }
    // less(obj);
}

function execJs(e, ext, obj, modulename, config) {
    /**
     * [basename description]
     * @type {[type]}
     * 手动的加入到main中
     */
    try {
        var basename = require("path").basename(e.path);
        var dirname = require("path").dirname(e.path);
        var parentMainPath = dirname + "/main.js";
        if (e.type == "added") {
            // 新增了
            var stat = fs.statSync(e.path);
            var isFile = stat.isFile();
            if (basename !== "main.js") {
                gulp.src(parentMainPath)
                    .pipe($.footer(isFile ? "require('./<%= path %>');\n" : "require('./<%= path %>/main');\n", { path: basename }))
                    .pipe(gulp.dest(dirname))
                    .on("end", function() {
                        // 结束了 开始执行browserify的操作
                        if (!isFile) {
                            // 不是个文件 是文件夹
                            var ws1 = fs.createWriteStream($path.join(e.path, "./main.js"));
                            ws1.write("angular.module('" + modulename + "')\n");
                            ws1.end();
                            browserify(obj, null, config);
                        } else {
                            fs.writeFile(e.path, "angular.module('" + modulename + "')\n", { encoding: "utf8" }, function() {
                                browserify(obj, null, config);
                            });
                        }
                    })
            }
        } else if (e.type == 'deleted' && ext) {
            var ext = $path.extname(e.path);
            if (ext) {
                var basename = $path.basename(e.path, ".js");
                var dirname = $path.dirname(e.path);
                var state = fs.statSync(dirname + "/main.js");
                if (state.isFile()) {
                    //是个文件  读取文件
                    var content_ = fs.readFileSync(dirname + "/main.js").toString();
                    var require_reg = new RegExp("require\\((\'|" + '\"\\.' + $path.sep + ')(' + basename + "|" + basename + ".js)(\'" + '|\")' + "\\);", "gi");
                    content_ = content_.replace(require_reg, "");
                    fs.writeFile(dirname + "/main.js", content_, {
                        encoding: "utf-8"
                    })
                }
                // 找到期目录下的main
            }
        } else {
            browserify(obj, null, config);
        }
    } catch (e) {
        console.log(e);
    }
}

function mix(a, b) {
    if (typeof b == "object") {
        for (var i in b) {
            if (!a.hasOwnProperty(i)) {
                a[i] = b[i];
            } else {
                // 有
                a[i] = mix(a[i], b[i]);
            }
        }
    } else {
        a = b;
    }
    return a;
};
var handleError = function(err) {
    var str = err.toString();
    var reg = /\".+?\"/gi;
    var content = /[^\"]+/gi;
    console.log(str);
    var matcharr = str.match(reg);
    var name = matcharr && matcharr instanceof Array ? str.match(reg)[0].match(content)[0] : null;
    if (matcharr && matcharr instanceof Array) {
        var name = str.match(reg)[0].match(content)[0];
        var msg = err.message;
        var maindir = $path.dirname(msg.match(reg)[1].match(content)[0]);
        var mainPath = maindir + "/main.js";
        var content_ = fs.readFileSync(mainPath).toString();
        var require_reg = new RegExp("require\\((\'|" + '\")(' + name + "|" + name + ".js)(\'" + '|\")' + "\\);", "gi")
        content_ = content_.replace(require_reg, "");
        // 将新的内容写入
        fs.writeFile(mainPath, content_, {
            encoding: "utf-8"
        })
        this.emit('end');
    }
};
var del = (function() {
    function iterator(url, dirs) {
        var stat = fs.statSync(url);
        if (stat.isDirectory()) {
            dirs.unshift(url); //收集目录
            inner(url, dirs);
        } else if (stat.isFile()) {
            fs.unlinkSync(url); //直接删除文件
        }
    }

    function inner(path, dirs) {
        var arr = fs.readdirSync(path);
        for (var i = 0, el; el = arr[i++];) {
            iterator(path + "/" + el, dirs);
        }
    }
    return function(dir, cb) {
        cb = cb || function() {};
        var dirs = [];
        try {
            iterator(dir, dirs);
            for (var i = 0, el; el = dirs[i++];) {
                fs.rmdirSync(el); //一次性删除所有收集到的目录
            }
            cb()
        } catch (e) { //如果文件或目录本来就不存在，fs.statSync会报错，不过我们还是当成没有异常发生
            e.code === "ENOENT" ? cb() : cb(e);
        }
    }
})();
module.exports = app;